/* Program pro jednoduche odzkouseni ovladani osmi rele z LASKARDUINO
 * spinani relatek je signalem LOW z ULN2803A rizenym posuvnym registrem 
 * 74HC595 zadavani hodnot pro rele je z pocitace PC terminalem 
 * pro seriovou komunikaci prevodnikem USB/COM-TTL CH340 
 * vagnervlastimil@seznam.cz
 */
#define data 2                   //PIN 2 Arduino UNO seriovy vstup dat do 74HC595 PIN 14 
#define potvrd 3                 //PIN 3 Arduino UNO potvrzeni dat PIN 12 RCLK 74HC595
#define clk 4                    //PIN 4 Arduino UNO CLK takt pro posun bitu PIN 11 74HC595 
#define povol 5                  //PIN 5 Arduino Uno po zapnuti vystupy 74HC595 do LOW PIN 13 OE NEG
int hodnota;                     //definovani promennych

void setup() {                   //zadani parametru
  pinMode(potvrd, OUTPUT);       //nastaveni PINU 3 na vystup
  pinMode(clk, OUTPUT);          //nastaveni PINU 4 na vystup 
  pinMode(data, OUTPUT);         //nastaveni PINU 2 na vystup
  pinMode(povol, OUTPUT);        //nastaveni PINU 5 na vystup
  Serial.begin(9600);            //funkce pro komunikaci serioveho portu 
  digitalWrite(povol, LOW);      //zapnuti PINU 5 na LOW povoleni ovladani 74HC595
  delay(1000);                   //casova prodleva po zapnuti PINU 5 na LOW
}

void loop(){                     //hlavni program
 if (Serial.available() > 0){    //testovani vstupu zda prisli data   
    hodnota=Serial.parseInt();   // nacteni dat a ulozeni do promenne cti.
    Serial.print("prijato: ");   //odeslani slova "cti :" do terminalu v PC
    Serial.print(hodnota);       //odeslani nactene hodnoty v promenne "cti" do terminalu v PC
    Serial.println();            //odradkovani na dalsi radek
    posli(hodnota);              //zavolani funkce posli a predani ciselne hodnoty pro vystupy xxHC595
  } 
}

void posli(int hodnota){               //funkce pro vypocet a zadavani vystupnich hodnot
  digitalWrite(potvrd, LOW);           //nastaveni potvrzeni dat na LOW umozni zapis dat
  delay(5);                            //casova prodleva
  shiftOut(data,clk,MSBFIRST,hodnota); //odeslani zadaných hodnot do posuvneho registru
  digitalWrite(potvrd,HIGH);           //zapnuti pinu potvrzeni platnosti dat
    delay(5);                          //casova prodleva
    } 
      
